> ## Documentation Index
> Fetch the complete documentation index at: https://gcore.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Retrieve a list of insights

> Retrieve a list of insights for a specific domain.



## OpenAPI

````yaml /api-reference/services_documented/waap_api.yaml get /waap/v1/domains/{domain_id}/insights
openapi: 3.1.0
info:
  title: Gcore OpenAPI – WAAP API
  description: >-
    This OpenAPI is an aggregated OpenAPI specification that unifies all Gcore
    products into a single file. It covers Cloud, CDN, DNS, WAAP, DDoS
    Protection, Object Storage, Streaming, and FastEdge services.
  version: '2026-05-11T15:10:30.328297+00:00'
servers:
  - url: https://api.gcore.com
security:
  - APIKey: []
tags:
  - name: WAAP Service
    x-displayName: WAAP Service
  - name: Domains
    x-displayName: Domains
  - name: Policies
    x-displayName: Policies
  - name: Analytics
    x-displayName: Analytics
  - name: Custom Page Sets
    x-displayName: Custom Page Sets
  - name: Custom Rules
    x-displayName: Custom Rules
  - name: Filter Templates
    x-displayName: Filter Templates
  - name: Firewall Rules
    x-displayName: Firewall Rules
  - name: Advanced Rules
    x-displayName: Advanced Rules
  - name: Tags
    x-displayName: Tags
  - name: Network Organizations
    x-displayName: Network Organizations
  - name: API Discovery
    x-displayName: API Discovery
  - name: IP Spotlight
    x-displayName: IP Spotlight
  - name: Security Insights
    x-displayName: Security Insights
  - name: IP Reputation
    x-displayName: IP Reputation
paths:
  /waap/v1/domains/{domain_id}/insights:
    get:
      tags:
        - Security Insights
      summary: Retrieve a list of insights
      description: Retrieve a list of insights for a specific domain.
      operationId: get_insights_v1_domains__domain_id__insights_get
      parameters:
        - name: domain_id
          in: path
          required: true
          schema:
            type: integer
            exclusiveMinimum: 0
            description: The domain ID
            title: Domain Id
          description: The domain ID
        - name: ordering
          in: query
          required: false
          schema:
            $ref: '#/components/schemas/InsightSortBy'
            description: Sort the response by given field.
            default: '-last_seen'
        - name: limit
          in: query
          required: false
          schema:
            type: integer
            maximum: 100
            minimum: 0
            description: Number of items to return
            default: 100
            title: Limit
          description: Number of items to return
        - name: offset
          in: query
          required: false
          schema:
            type: integer
            maximum: 100000
            minimum: 0
            description: Number of items to skip
            default: 0
            title: Offset
          description: Number of items to skip
        - name: id
          in: query
          required: false
          schema:
            anyOf:
              - type: array
                items:
                  type: string
                  format: uuid
              - type: 'null'
            description: The ID of the insight
            title: Id
          description: The ID of the insight
        - name: insight_type
          in: query
          required: false
          schema:
            anyOf:
              - type: array
                items:
                  type: string
              - type: 'null'
            description: The type of the insight
            title: Insight Type
          description: The type of the insight
        - name: status
          in: query
          required: false
          schema:
            anyOf:
              - type: array
                items:
                  $ref: '#/components/schemas/InsightStatus'
              - type: 'null'
            description: The status of the insight
            title: Status
          description: The status of the insight
        - name: description
          in: query
          required: false
          schema:
            anyOf:
              - type: string
                maxLength: 450
              - type: 'null'
            description: The description of the insight. Supports '*' as a wildcard.
            title: Description
          description: The description of the insight. Supports '*' as a wildcard.
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PaginatedResponse_Insight_'
        '400':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/APIError'
              example:
                type: http-bad-request
                title: Bad Request
                status: 400
                detail: 'Invalid domain name: '''''''''
          description: Bad Request
        '401':
          description: Unauthorized
          content:
            application/problem+json:
              example:
                detail: Auth token is missing or invalid
        '403':
          description: Unauthenticated
          content:
            application/problem+json:
              example:
                detail: Permission denied
        '404':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/APIError'
              example:
                type: http-not-found
                title: Not Found
                status: 404
                detail: The resource is not found
          description: Not Found
        '422':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/APICompositeError'
              example:
                type: request-validation-failed
                title: Request validation error.
                status: 422
                detail: One or more fields have validation errors.
                errors:
                  - loc:
                      - body
                      - name
                    detail: Input should be a valid string
                  - loc:
                      - body
                      - date
                    detail: Field required
                  - loc:
                      - query
                      - limit
                    detail: Field required
          description: Unprocessable Entity
        '500':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/APIError'
              example:
                type: internal-server-error
                title: Internal server error.
                status: 500
                detail: >-
                  An unexpected condition was encountered which prevented the
                  server from fulfilling the request.
          description: Internal Server Error
      x-codeSamples:
        - lang: Python
          source: |-
            import os
            from gcore import Gcore

            client = Gcore(
                api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
            )
            page = client.waap.domains.insights.list(
                domain_id=1,
            )
            page = page.results[0]
            print(page.id)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/G-Core/gcore-go\"\n\t\"github.com/G-Core/gcore-go/option\"\n\t\"github.com/G-Core/gcore-go/waap\"\n)\n\nfunc main() {\n\tclient := gcore.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tpage, err := client.Waap.Domains.Insights.List(\n\t\tcontext.TODO(),\n\t\t1,\n\t\twaap.DomainInsightListParams{},\n\t)\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", page)\n}\n"
components:
  schemas:
    InsightSortBy:
      type: string
      enum:
        - id
        - '-id'
        - insight_type
        - '-insight_type'
        - first_seen
        - '-first_seen'
        - last_seen
        - '-last_seen'
        - last_status_change
        - '-last_status_change'
        - status
        - '-status'
      title: InsightSortBy
    InsightStatus:
      type: string
      enum:
        - OPEN
        - ACKED
        - CLOSED
      title: InsightStatus
      description: The different statuses an insight can have
    PaginatedResponse_Insight_:
      properties:
        limit:
          type: integer
          title: Limit
          description: Number of items requested in the response
        offset:
          type: integer
          title: Offset
          description: Items response offset used
        count:
          type: integer
          title: Count
          description: Number of items contain in the response
        results:
          items:
            $ref: '#/components/schemas/Insight'
          type: array
          title: Results
          description: List of items returned in the response following given criteria
      type: object
      required:
        - limit
        - offset
        - count
        - results
      title: PaginatedResponse[Insight]
    APIError:
      properties:
        type:
          type: string
          title: Type
          description: A URI identifier that categorizes the type of error.
        title:
          type: string
          title: Title
          description: A brief, human-readable title for the error.
        status:
          type: integer
          title: Status
          description: The HTTP status code applicable to this error.
        detail:
          anyOf:
            - type: string
            - type: 'null'
          title: Detail
          description: A detailed human-readable explanation of the error.
      type: object
      required:
        - type
        - title
        - status
        - detail
      title: APIError
    APICompositeError:
      properties:
        type:
          type: string
          title: Type
          description: A URI identifier that categorizes the type of error.
        title:
          type: string
          title: Title
          description: A brief, human-readable title for the error.
        status:
          type: integer
          title: Status
          description: The HTTP status code applicable to this error.
        detail:
          anyOf:
            - type: string
            - type: 'null'
          title: Detail
          description: A detailed human-readable explanation of the error.
        errors:
          items:
            $ref: '#/components/schemas/APIFieldError'
          type: array
          title: Errors
          description: A list of detailed errors for individual fields.
      type: object
      required:
        - type
        - title
        - status
        - detail
        - errors
      title: APICompositeError
    Insight:
      properties:
        id:
          type: string
          format: uuid
          title: Id
          description: A generated unique identifier for the insight
        insight_type:
          type: string
          pattern: ^[a-z0-9]+(?:-[a-z0-9]+)*$
          title: Insight Type
          description: The slug of the insight type
        labels:
          additionalProperties:
            type: string
          type: object
          title: Labels
          description: A hash table of label names and values that apply to the insight
        first_seen:
          type: string
          format: date-time
          title: First Seen
          description: The date and time the insight was first seen in ISO 8601 format
        last_seen:
          type: string
          format: date-time
          title: Last Seen
          description: The date and time the insight was last seen in ISO 8601 format
        last_status_change:
          type: string
          format: date-time
          title: Last Status Change
          description: The date and time the insight was last seen in ISO 8601 format
        status:
          $ref: '#/components/schemas/InsightStatus'
          description: The status of the insight
        description:
          type: string
          maxLength: 450
          minLength: 3
          title: Description
          description: The description of the insight
          example: >-
            A request originated from a high-risk IP: 1.2.3.4, but it was
            allowed by rule: 'my custom rule' the description of the insight
          examples:
            - >-
              A request originated from a high-risk IP: 1.2.3.4, but it was
              allowed by rule: 'my custom rule' the description of the insight
        recommendation:
          type: string
          maxLength: 450
          minLength: 3
          title: Recommendation
          description: The recommended action to perform to resolve the insight
          example: disable or delete rule "my-custom-rule"
          examples:
            - disable or delete rule "my-custom-rule"
      type: object
      required:
        - id
        - insight_type
        - labels
        - first_seen
        - last_seen
        - last_status_change
        - status
        - description
        - recommendation
      title: Insight
    APIFieldError:
      properties:
        loc:
          anyOf:
            - items:
                anyOf:
                  - type: integer
                  - type: string
              type: array
            - {}
          title: Loc
          description: The location of the field or a character number causing the error.
        detail:
          type: string
          title: Detail
          description: A human-readable message describing the error.
      type: object
      required:
        - loc
        - detail
      title: APIFieldError
  securitySchemes:
    APIKey:
      description: >-
        API key for authentication. Make sure to include the word `apikey`,
        followed by a single space and then your token.

        Example: `apikey 1234$abcdef`
      type: apiKey
      in: header
      name: Authorization

````